﻿Public Class Form1

    Private Function fncNumericConvert(ByVal varCheckData As Object) As Decimal
        ' ***** 文字列の数値化 *****

        ' /* 計算誤差を防ぐため文字列に変換 */
        If IsNumeric(varCheckData) Then Return CDec(varCheckData)
        Return 0
    End Function

    Private Sub subComboSet(ByRef cboName As ComboBox, ByVal strList As String)
        ' ***** コンボボックスに候補を設定する *****
        Dim strDropList() As String = Split(strList, "|")
        cboName.DropDownStyle = ComboBoxStyle.DropDownList
        cboName.Items.Clear()
        cboName.Items.AddRange(strDropList)
        cboName.SelectedIndex = 0
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' /* inpExModeプロパティ */
        Call subComboSet(cboInputMode, "カンマなし数値|カンマ付き数値|短い日付|長い日付|短い日付+時間|長い日付+時間|文字列|複数行文字列|計算式")
        ' /* inpExLengthプロパティ */
        txtLength.Text = -5.2
        ' /* inpExValueプロパティ */
        txtValue.Text = "-12.61"

        ' /* inpExButtonSizeプロパティ */
        txtButtonSize.Text = 30
        ' /* inpExButtonColorプロパティ */
        Call subComboSet(cboBottonColor, "マゼンタ|青色|黄色|グレー")
        ' /* inpExButtonNameプロパティ */
        txtButtonName.Text = "cmdInutExButton"

        ' /* inpExMinusNumberColorプロパティ */
        Call subComboSet(cboMinusNumberColor, "赤|黒")
        ' /* inpExRangeCheckプロパティ */
        Call subComboSet(cboRangeCheck, "なし|する")
        ' /* inpExMinimumプロパティ */
        txtMinimum.Text = 10
        ' /* inpExMaximumプロパティ */
        txtMaximum.Text = 100
        ' /* inpExBaseValueプロパティ */
        txtBaseValue.Text = 100
        ' /* inpExRoundプロパティ */
        Call subComboSet(cboRound, "四捨五入|切捨て|切上げ")

        ' /* inpExInvalidCharacterプロパティ */
        txtInvalidCharacter.Text = "\,'"
        ' /* inpExCharacterCasingプロパティ */
        Call subComboSet(cboCharacterCasing, "標準|大文字変換|小文字変換")
        ' /* inpExSelectTextプロパティ */
        Call subComboSet(cboSelectText, "なし|選択状態")
        ' /* ImeModeプロパティ */
        Call subComboSet(cboIME, "使用禁止|ひらがな|半角カタカナ|Off")
        ' /* inpExScrollBarsプロパティ */
        Call subComboSet(cboScrollBars, "なし|水平|垂直|両方")

        lblTextChang.Text = ""
        lblValue.Text = ""
        lblExTextCganged.Text = ""
        lblButtonClick.Text = ""
    End Sub

    Private Sub InputEx1_inpExClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles InputEx1.inpExClick
        ' ***** InpuExのボタンがクリックされた *****
        If chkList.Checked Then
            ' /* 一覧表を表示(inpExImeModeサンプル用)
            Form2.ShowDialog(Me)
            Select Case Me.Tag
                Case "Disable"
                    InputEx1.inpExImeMode = Windows.Forms.ImeMode.Disable
                Case "Hiragana"
                    InputEx1.inpExImeMode = Windows.Forms.ImeMode.Hiragana
                Case "Katakana"
                    InputEx1.inpExImeMode = Windows.Forms.ImeMode.Katakana
                Case "KatakanaHalf"
                    InputEx1.inpExImeMode = Windows.Forms.ImeMode.KatakanaHalf
                Case "AlphaFull"
                    InputEx1.inpExImeMode = Windows.Forms.ImeMode.AlphaFull
                Case Else ' "Alpha"
                    InputEx1.inpExImeMode = Windows.Forms.ImeMode.Alpha
            End Select
        Else
            lblButtonClick.Text = "ボタンがクリックされました"
        End If
    End Sub

    Private Sub cboInputMode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboInputMode.SelectedIndexChanged
        ' ***** InputExコントロールのInputModeを変更した時、入力できる項目を変更する *****
        Select Case cboInputMode.Text
            Case "カンマなし数値", "カンマ付き数値"
                grpSetNumeric.Enabled = True
                grpSetString.Enabled = False
                grpCalculate.Enabled = False
                cboMinusNumberColor.Enabled = True
            Case "計算式"
                grpSetNumeric.Enabled = True
                grpSetString.Enabled = False
                grpCalculate.Enabled = True
                cboMinusNumberColor.Enabled = False
            Case "短い日付", "長い日付", "短い日付+時間", "長い日付+時間"
                grpSetNumeric.Enabled = False
                grpSetString.Enabled = False
                grpCalculate.Enabled = False
            Case "文字列", "複数行文字列"
                grpSetNumeric.Enabled = False
                grpSetString.Enabled = True
                grpCalculate.Enabled = False
        End Select
    End Sub

    Private Sub cboRangeCheck_SelectedIndexChanged(sender As Object, e As System.EventArgs) Handles cboRangeCheck.SelectedIndexChanged
        ' ***** InputExコントロールのRangeCheckを変更した時、入力できる項目を変更する *****
        Select Case cboRangeCheck.Text
            Case "する"
                txtMaximum.Enabled = True
                txtMinimum.Enabled = True
            Case Else
                txtMaximum.Enabled = False
                txtMinimum.Enabled = False
        End Select
    End Sub

    Private Sub cmdGet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdGet.Click
        ' /* inpextChangeプロパティは、inpEXValueの前に取得すること */
        lblTextChang.Text = "TextChangeプロパティ:" & InputEx1.inpExTextChange.ToString
        lblValue.Text = "Valueプロパティ:" & InputEx1.inpExValue.ToString
        lblExTextCganged.Text = ""
    End Sub

    Private Sub cmdSet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSet.Click
        ' ***** InputExコントロールにプロパティを設定する *****
        Dim strError As String = ""

        If txtButtonName.Text.Length < 1 Then
            strError = "ボタンの名前が不正です"
        Else
            Select Case cboInputMode.Text
                Case "カンマなし数値", "カンマ付き数値", "計算式"
                    If fncNumericConvert(txtLength.Text) = 0 Then strError = "入力桁数が不正です"
                    If cboRangeCheck.Text = "する" Then
                        Dim decRange() As Decimal = {fncNumericConvert(txtMinimum.Text), fncNumericConvert(txtMaximum.Text)}
                        txtMinimum.Text = decRange(0).ToString
                        txtMaximum.Text = decRange(1).ToString
                        If decRange(0) >= decRange(1) Then strError = "範囲指定が不正です"
                    End If
                    txtBaseValue.Text = fncNumericConvert(txtBaseValue.Text).ToString
                Case "短い日付", "長い日付", "短い日付+時間", "長い日付+時間"
                Case "文字列", "複数行文字列"
                    If fncNumericConvert(txtLength.Text) < 1 Then strError = "入力桁数が不正です"
            End Select
        End If

        If strError.Length Then
            MessageBox.Show(strError, "inpEx-Test", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If

        With InputEx1
            Select Case cboInputMode.Text
                Case "カンマなし数値"
                    .inpExMode = InputEx.InputEx.eInputMode.inpExNumber
                    .inpExRengeCheck = IIf(cboRangeCheck.Text = "する", True, False)
                    .inpExMinimum = txtMinimum.Text
                    .inpExMaximum = txtMaximum.Text
                 Case "カンマ付き数値"
                    .inpExMode = InputEx.InputEx.eInputMode.inpExNumberComma
                    .inpExRengeCheck = IIf(cboRangeCheck.Text = "する", True, False)
                    .inpExMinimum = txtMinimum.Text
                    .inpExMaximum = txtMaximum.Text
                Case "計算式"
                    .inpExMode = InputEx.InputEx.eInputMode.inpExColculate
                    .inpExRengeCheck = IIf(cboRangeCheck.Text = "する", True, False)
                    .inpExMinimum = txtMinimum.Text
                    .inpExMaximum = txtMaximum.Text
                    .inpExBaseValue = txtBaseValue.Text
                    .inpExRound = cboRound.SelectedIndex + 1
                Case "短い日付"
                    .inpExMode = InputEx.InputEx.eInputMode.inpExSimpleDate
                Case "長い日付"
                    .inpExMode = InputEx.InputEx.eInputMode.inpExFullDate
                Case "短い日付+時間"
                    .inpExMode = InputEx.InputEx.eInputMode.inpExSimpleDateTime
                Case "長い日付+時間"
                    .inpExMode = InputEx.InputEx.eInputMode.inpExFullDateTime
                Case "文字列"
                    .inpExMode = InputEx.InputEx.eInputMode.inpExString
                Case "複数行文字列"
                    .inpExMode = InputEx.InputEx.eInputMode.inpExMultilineString
            End Select
            '.Size = New Size(370, 26)
            .inpExLength = txtLength.Text
            .inpExButtonSize = fncNumericConvert(txtButtonSize.Text)
            Select Case cboBottonColor.Text
                Case "マゼンタ" : .inpExButtonColor = Color.Magenta
                Case "青色" : .inpExButtonColor = Color.Blue
                Case "黄色" : .inpExButtonColor = Color.Yellow
                Case "グレー" : .inpExButtonColor = Color.Gray
            End Select
            .inpExButtonName = txtButtonName.Text
            .inpExInvalidCharacter = txtInvalidCharacter.Text
            Select Case (cboCharacterCasing.Text)
                Case "標準" : .inpExCharacterCasing = InputEx.InputEx.eCharacterCast.inpExNomal
                Case "大文字変換" : .inpExCharacterCasing = InputEx.InputEx.eCharacterCast.inpExUpper
                Case "小文字変換" : .inpExCharacterCasing = InputEx.InputEx.eCharacterCast.inpExLower
            End Select
            If cboMinusNumberColor.Text = "赤" Then
                .inpExMinusNumberColor = Color.Red
            Else
                .inpExMinusNumberColor = Color.Black
            End If
            If cboSelectText.Text = "なし" Then
                .inpExSelectText = InputEx.InputEx.eSign.inpExNo
            Else
                .inpExSelectText = InputEx.InputEx.eSign.inpExYes
            End If
            .inpExValue = txtValue.Text
            Select Case cboIME.Text
                Case "使用禁止" : .ImeMode = Windows.Forms.ImeMode.Disable
                Case "ひらがな" : .ImeMode = Windows.Forms.ImeMode.Hiragana
                Case "半角カタカナ" : .ImeMode = Windows.Forms.ImeMode.KatakanaHalf
                Case "Off" : .ImeMode = Windows.Forms.ImeMode.Off
            End Select
            .inpExScrollBars = cboScrollBars.SelectedIndex
        End With

        InputEx1.Focus()
    End Sub

    Private Sub InputEx1_inpExTextCganged(ByVal sender As Object, ByVal e As System.EventArgs) Handles InputEx1.inpExTextCganged
        lblExTextCganged.Text = "inpExTextCganged Events(編集中)"
    End Sub
End Class